<?php

namespace App\Support\Traits;

use App\Services\SysLogService;
use Illuminate\Support\Str;

trait HttpClientHelpers
{

    protected function getPostClient($uri, $paramsBody, $auth = null, $header = null, $json = true)
    {
        $client = app(\GuzzleHttp\Client::class);
        $options = [];

        if(!is_null($header)){
            $options['headers'] = $header;
        }

        if($json) {
           $options['headers'] = [
               'Content-type'=> 'application/json',
               "Accept" => "application/json"
           ];

           $options['json'] = $paramsBody;
        }
        else{
            $options['form_params'] = $paramsBody;
        }

        if($auth && is_array($auth)){
            $options['auth'] = $auth;
        }

        $options['debug'] = env('API_DEBUG');

        $response = $client->request('post',$uri,$options);

        $responseContent = $response->getBody()->getContents();

        app(SysLogService::class)->addApiLogs($responseContent);

        return $responseContent;
    }
}
